unit WpMain1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TMainForm = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    BitmapFolder: String;
    BitmapList: TStringList;
    procedure FindBitmaps(Folder: String);
    procedure ChangeWallpaper(Wallpaper: String);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  Registry;

{---------------------- TMainForm ---------------------}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  BitmapList := TStringList.Create;
end;


procedure TMainForm.FormDestroy(Sender: TObject);
begin
  BitmapList.Free;
end;


procedure TMainForm.FindBitmaps(Folder: String);
var
  Found: Integer;
  SearchRec: TSearchRec;
begin
  BitmapList.Clear;
  // First File
  Found := FindFirst(Folder+'\*.bmp', faAnyFile, SearchRec);
  while Found = 0 do
  begin
    // Don't get the special directories ('.' and '..')
    if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then
      BitmapList.Add(Folder+'\'+SearchRec.Name);
    Found := FindNext(SearchRec);
  end;
  FindClose(SearchRec);
end;


procedure TMainForm.Button1Click(Sender: TObject);
var
  I: Integer;
begin
  BitmapFolder := Edit1.Text;
  FindBitmaps(BitmapFolder);
  if BitmapList.Count > 0 then
  begin
    Randomize;
    I := Random(BitmapList.Count);
    ChangeWallpaper(BitmapList[I]);
  end
  else
    MessageDlg('No bitmaps in the specified folder.', mtError, [mbOk], 0);
end;


procedure TMainForm.ChangeWallpaper(Wallpaper: string);
begin
  SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, PChar(Wallpaper), SPIF_UPDATEINIFILE);
end;

{
procedure TMainForm.ChangeWallpaper(Wallpaper: String);
var
  Registry: TRegistry;
begin
  ShowMessage(Wallpaper);
  Registry := TRegistry.Create;
  Registry.RootKey := HKEY_CURRENT_USER;
  if Registry.OpenKey('Software\Microsoft\Internet Explorer\Desktop\General', False) then
    Registry.WriteString('BackupWallpaper', Wallpaper)
  else
    MessageDlg('Could not write to registry.', mtError, [mbOk], 0);
  Registry.Free;
end;
}
end.

